/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { StoredSchemaCollection } from "../../../core/index.js";
import { JsonCompatibleReadOnly } from "../../../util/index.js";
import { ICodecOptions, IJsonCodec } from "../../../codec/index.js";
import { FullSchemaPolicy } from "../../modular-schema/index.js";
import { TreeCompressionStrategy } from "../../treeCompressionUtils.js";
import { EncodedFieldBatch } from "./format.js";
import { FieldBatch } from "./fieldBatch.js";
export interface FieldBatchEncodingContext {
    readonly encodeType: TreeCompressionStrategy;
    readonly schema?: SchemaAndPolicy;
}
export interface SchemaAndPolicy {
    readonly schema: StoredSchemaCollection;
    readonly policy: FullSchemaPolicy;
}
export type FieldBatchCodec = IJsonCodec<FieldBatch, EncodedFieldBatch, JsonCompatibleReadOnly, FieldBatchEncodingContext>;
export declare function makeFieldBatchCodec(options: ICodecOptions): FieldBatchCodec;
//# sourceMappingURL=codecs.d.ts.map