/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { ICodecFamily, IJsonCodec } from "../../codec/index.js";
import { ChangeEncodingContext, EncodedRevisionTag, RevisionTag } from "../../core/index.js";
import { JsonCompatibleReadOnly } from "../../util/index.js";
import type { NodeChangeset } from "../modular-schema/index.js";
import type { OptionalChangeset } from "./optionalFieldChangeTypes.js";
export declare const noChangeCodecFamily: ICodecFamily<0, ChangeEncodingContext>;
export declare const makeOptionalFieldCodecFamily: <TChildChange = NodeChangeset>(childCodec: IJsonCodec<TChildChange, JsonCompatibleReadOnly, JsonCompatibleReadOnly, ChangeEncodingContext>, revisionTagCodec: IJsonCodec<RevisionTag, EncodedRevisionTag, EncodedRevisionTag, ChangeEncodingContext>) => ICodecFamily<OptionalChangeset<TChildChange>, ChangeEncodingContext>;
//# sourceMappingURL=optionalFieldCodecs.d.ts.map