/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { ICodecOptions, IJsonCodec, IMultiFormatCodec } from "../codec/index.js";
import { ChangeEncodingContext, EncodedRevisionTag, RevisionTag } from "../core/index.js";
import { SchemaAndPolicy } from "../feature-libraries/index.js";
import { JsonCompatibleReadOnly } from "../util/index.js";
import { SummaryData } from "./editManager.js";
export interface EditManagerEncodingContext {
    readonly schema?: SchemaAndPolicy;
}
export declare function makeEditManagerCodec<TChangeset>(changeCodec: IMultiFormatCodec<TChangeset, JsonCompatibleReadOnly, JsonCompatibleReadOnly, ChangeEncodingContext>, revisionTagCodec: IJsonCodec<RevisionTag, EncodedRevisionTag, EncodedRevisionTag, ChangeEncodingContext>, options: ICodecOptions): IJsonCodec<SummaryData<TChangeset>, JsonCompatibleReadOnly, JsonCompatibleReadOnly, ChangeEncodingContext>;
//# sourceMappingURL=editManagerCodecs.d.ts.map