/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { Static } from "@sinclair/typebox";
export declare const EncodedSharedTreeInnerChange: import("@sinclair/typebox").TObject<{
    schema: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
        new: import("@sinclair/typebox").TObject<{
            version: import("@sinclair/typebox").TLiteral<1>;
            nodes: import("@sinclair/typebox").TRecord<import("@sinclair/typebox").TString, import("@sinclair/typebox").TObject<{
                object: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TRecord<import("@sinclair/typebox").TString, import("@sinclair/typebox").TObject<{
                    kind: import("@sinclair/typebox").TUnsafe<import("../index.js").FieldKindIdentifier>;
                    types: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TUnsafe<import("../index.js").TreeNodeSchemaIdentifier<string>>>>;
                }>>>;
                map: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                    kind: import("@sinclair/typebox").TUnsafe<import("../index.js").FieldKindIdentifier>;
                    types: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TUnsafe<import("../index.js").TreeNodeSchemaIdentifier<string>>>>;
                }>>;
                leaf: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TEnum<typeof import("../core/schema-stored/format.js").PersistedValueSchema>>;
            }>>;
            root: import("@sinclair/typebox").TObject<{
                kind: import("@sinclair/typebox").TUnsafe<import("../index.js").FieldKindIdentifier>;
                types: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TUnsafe<import("../index.js").TreeNodeSchemaIdentifier<string>>>>;
            }>;
        }>;
        old: import("@sinclair/typebox").TObject<{
            version: import("@sinclair/typebox").TLiteral<1>;
            nodes: import("@sinclair/typebox").TRecord<import("@sinclair/typebox").TString, import("@sinclair/typebox").TObject<{
                object: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TRecord<import("@sinclair/typebox").TString, import("@sinclair/typebox").TObject<{
                    kind: import("@sinclair/typebox").TUnsafe<import("../index.js").FieldKindIdentifier>;
                    types: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TUnsafe<import("../index.js").TreeNodeSchemaIdentifier<string>>>>;
                }>>>;
                map: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                    kind: import("@sinclair/typebox").TUnsafe<import("../index.js").FieldKindIdentifier>;
                    types: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TUnsafe<import("../index.js").TreeNodeSchemaIdentifier<string>>>>;
                }>>;
                leaf: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TEnum<typeof import("../core/schema-stored/format.js").PersistedValueSchema>>;
            }>>;
            root: import("@sinclair/typebox").TObject<{
                kind: import("@sinclair/typebox").TUnsafe<import("../index.js").FieldKindIdentifier>;
                types: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TUnsafe<import("../index.js").TreeNodeSchemaIdentifier<string>>>>;
            }>;
        }>;
    }>>;
    data: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
        maxId: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../index.js").ChangesetLocalId>>;
        changes: import("@sinclair/typebox").TArray<import("@sinclair/typebox").TObject<{
            fieldKey: import("@sinclair/typebox").TUnsafe<import("../index.js").FieldKey>;
            fieldKind: import("@sinclair/typebox").TUnsafe<import("../index.js").FieldKindIdentifier>;
            change: import("@sinclair/typebox").TAny;
        }>>;
        revisions: import("@sinclair/typebox").TReadonlyOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TObject<{
            revision: import("@sinclair/typebox").TReadonly<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TLiteral<"root">, import("@sinclair/typebox").TUnsafe<import("../index.js").Brand<import("@fluidframework/id-compressor").OpSpaceCompressedId, "EncodedRevisionTag">>]>>;
            rollbackOf: import("@sinclair/typebox").TReadonlyOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TLiteral<"root">, import("@sinclair/typebox").TUnsafe<import("../index.js").Brand<import("@fluidframework/id-compressor").OpSpaceCompressedId, "EncodedRevisionTag">>]>>;
        }>>>;
        builds: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            builds: import("@sinclair/typebox").TArray<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../index.js").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>, import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TLiteral<"root">, import("@sinclair/typebox").TUnsafe<import("../index.js").Brand<import("@fluidframework/id-compressor").OpSpaceCompressedId, "EncodedRevisionTag">>]>]>, import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../index.js").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>]>]>>;
            trees: import("@sinclair/typebox").TObject<{
                version: import("@sinclair/typebox").TIntersect<[import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TLiteral<number>]>;
                data: import("@sinclair/typebox").TArray<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TAny>>;
                identifiers: import("@sinclair/typebox").TArray<import("@sinclair/typebox").TString>;
                shapes: import("@sinclair/typebox").TArray<import("@sinclair/typebox").TObject<{
                    a: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TNumber>;
                    b: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                        length: import("@sinclair/typebox").TNumber;
                        shape: import("@sinclair/typebox").TNumber;
                    }>>;
                    c: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                        type: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TString, import("@sinclair/typebox").TNumber]>>;
                        value: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TBoolean, import("@sinclair/typebox").TArray<import("@sinclair/typebox").TAny>]>>;
                        fields: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TString, import("@sinclair/typebox").TNumber]>, import("@sinclair/typebox").TNumber]>>>;
                        extraFields: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TNumber>;
                    }>>;
                    d: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TLiteral<0>>;
                }>>;
            }>;
        }>>;
        refreshers: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            builds: import("@sinclair/typebox").TArray<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../index.js").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>, import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TLiteral<"root">, import("@sinclair/typebox").TUnsafe<import("../index.js").Brand<import("@fluidframework/id-compressor").OpSpaceCompressedId, "EncodedRevisionTag">>]>]>, import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../index.js").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>]>]>>;
            trees: import("@sinclair/typebox").TObject<{
                version: import("@sinclair/typebox").TIntersect<[import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TLiteral<number>]>;
                data: import("@sinclair/typebox").TArray<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TAny>>;
                identifiers: import("@sinclair/typebox").TArray<import("@sinclair/typebox").TString>;
                shapes: import("@sinclair/typebox").TArray<import("@sinclair/typebox").TObject<{
                    a: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TNumber>;
                    b: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                        length: import("@sinclair/typebox").TNumber;
                        shape: import("@sinclair/typebox").TNumber;
                    }>>;
                    c: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                        type: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TString, import("@sinclair/typebox").TNumber]>>;
                        value: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TBoolean, import("@sinclair/typebox").TArray<import("@sinclair/typebox").TAny>]>>;
                        fields: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TString, import("@sinclair/typebox").TNumber]>, import("@sinclair/typebox").TNumber]>>>;
                        extraFields: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TNumber>;
                    }>>;
                    d: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TLiteral<0>>;
                }>>;
            }>;
        }>>;
    }>>;
}>;
export type EncodedSharedTreeInnerChange = Static<typeof EncodedSharedTreeInnerChange>;
export declare const EncodedSharedTreeChange: import("@sinclair/typebox").TArray<import("@sinclair/typebox").TObject<{
    schema: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
        new: import("@sinclair/typebox").TObject<{
            version: import("@sinclair/typebox").TLiteral<1>;
            nodes: import("@sinclair/typebox").TRecord<import("@sinclair/typebox").TString, import("@sinclair/typebox").TObject<{
                object: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TRecord<import("@sinclair/typebox").TString, import("@sinclair/typebox").TObject<{
                    kind: import("@sinclair/typebox").TUnsafe<import("../index.js").FieldKindIdentifier>;
                    types: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TUnsafe<import("../index.js").TreeNodeSchemaIdentifier<string>>>>;
                }>>>;
                map: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                    kind: import("@sinclair/typebox").TUnsafe<import("../index.js").FieldKindIdentifier>;
                    types: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TUnsafe<import("../index.js").TreeNodeSchemaIdentifier<string>>>>;
                }>>;
                leaf: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TEnum<typeof import("../core/schema-stored/format.js").PersistedValueSchema>>;
            }>>;
            root: import("@sinclair/typebox").TObject<{
                kind: import("@sinclair/typebox").TUnsafe<import("../index.js").FieldKindIdentifier>;
                types: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TUnsafe<import("../index.js").TreeNodeSchemaIdentifier<string>>>>;
            }>;
        }>;
        old: import("@sinclair/typebox").TObject<{
            version: import("@sinclair/typebox").TLiteral<1>;
            nodes: import("@sinclair/typebox").TRecord<import("@sinclair/typebox").TString, import("@sinclair/typebox").TObject<{
                object: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TRecord<import("@sinclair/typebox").TString, import("@sinclair/typebox").TObject<{
                    kind: import("@sinclair/typebox").TUnsafe<import("../index.js").FieldKindIdentifier>;
                    types: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TUnsafe<import("../index.js").TreeNodeSchemaIdentifier<string>>>>;
                }>>>;
                map: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                    kind: import("@sinclair/typebox").TUnsafe<import("../index.js").FieldKindIdentifier>;
                    types: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TUnsafe<import("../index.js").TreeNodeSchemaIdentifier<string>>>>;
                }>>;
                leaf: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TEnum<typeof import("../core/schema-stored/format.js").PersistedValueSchema>>;
            }>>;
            root: import("@sinclair/typebox").TObject<{
                kind: import("@sinclair/typebox").TUnsafe<import("../index.js").FieldKindIdentifier>;
                types: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TUnsafe<import("../index.js").TreeNodeSchemaIdentifier<string>>>>;
            }>;
        }>;
    }>>;
    data: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
        maxId: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../index.js").ChangesetLocalId>>;
        changes: import("@sinclair/typebox").TArray<import("@sinclair/typebox").TObject<{
            fieldKey: import("@sinclair/typebox").TUnsafe<import("../index.js").FieldKey>;
            fieldKind: import("@sinclair/typebox").TUnsafe<import("../index.js").FieldKindIdentifier>;
            change: import("@sinclair/typebox").TAny;
        }>>;
        revisions: import("@sinclair/typebox").TReadonlyOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TObject<{
            revision: import("@sinclair/typebox").TReadonly<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TLiteral<"root">, import("@sinclair/typebox").TUnsafe<import("../index.js").Brand<import("@fluidframework/id-compressor").OpSpaceCompressedId, "EncodedRevisionTag">>]>>;
            rollbackOf: import("@sinclair/typebox").TReadonlyOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TLiteral<"root">, import("@sinclair/typebox").TUnsafe<import("../index.js").Brand<import("@fluidframework/id-compressor").OpSpaceCompressedId, "EncodedRevisionTag">>]>>;
        }>>>;
        builds: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            builds: import("@sinclair/typebox").TArray<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../index.js").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>, import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TLiteral<"root">, import("@sinclair/typebox").TUnsafe<import("../index.js").Brand<import("@fluidframework/id-compressor").OpSpaceCompressedId, "EncodedRevisionTag">>]>]>, import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../index.js").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>]>]>>;
            trees: import("@sinclair/typebox").TObject<{
                version: import("@sinclair/typebox").TIntersect<[import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TLiteral<number>]>;
                data: import("@sinclair/typebox").TArray<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TAny>>;
                identifiers: import("@sinclair/typebox").TArray<import("@sinclair/typebox").TString>;
                shapes: import("@sinclair/typebox").TArray<import("@sinclair/typebox").TObject<{
                    a: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TNumber>;
                    b: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                        length: import("@sinclair/typebox").TNumber;
                        shape: import("@sinclair/typebox").TNumber;
                    }>>;
                    c: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                        type: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TString, import("@sinclair/typebox").TNumber]>>;
                        value: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TBoolean, import("@sinclair/typebox").TArray<import("@sinclair/typebox").TAny>]>>;
                        fields: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TString, import("@sinclair/typebox").TNumber]>, import("@sinclair/typebox").TNumber]>>>;
                        extraFields: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TNumber>;
                    }>>;
                    d: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TLiteral<0>>;
                }>>;
            }>;
        }>>;
        refreshers: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            builds: import("@sinclair/typebox").TArray<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../index.js").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>, import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TLiteral<"root">, import("@sinclair/typebox").TUnsafe<import("../index.js").Brand<import("@fluidframework/id-compressor").OpSpaceCompressedId, "EncodedRevisionTag">>]>]>, import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../index.js").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>]>]>>;
            trees: import("@sinclair/typebox").TObject<{
                version: import("@sinclair/typebox").TIntersect<[import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TLiteral<number>]>;
                data: import("@sinclair/typebox").TArray<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TAny>>;
                identifiers: import("@sinclair/typebox").TArray<import("@sinclair/typebox").TString>;
                shapes: import("@sinclair/typebox").TArray<import("@sinclair/typebox").TObject<{
                    a: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TNumber>;
                    b: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                        length: import("@sinclair/typebox").TNumber;
                        shape: import("@sinclair/typebox").TNumber;
                    }>>;
                    c: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                        type: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TString, import("@sinclair/typebox").TNumber]>>;
                        value: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TBoolean, import("@sinclair/typebox").TArray<import("@sinclair/typebox").TAny>]>>;
                        fields: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TString, import("@sinclair/typebox").TNumber]>, import("@sinclair/typebox").TNumber]>>>;
                        extraFields: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TNumber>;
                    }>>;
                    d: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TLiteral<0>>;
                }>>;
            }>;
        }>>;
    }>>;
}>>;
export type EncodedSharedTreeChange = Static<typeof EncodedSharedTreeChange>;
//# sourceMappingURL=sharedTreeChangeFormat.d.ts.map