/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { ITreeCursor } from "../../../core/index.js";
export declare function sum(cursor: ITreeCursor): number;
export declare function sumMap(cursor: ITreeCursor): number;
export declare function sumDirect(jsonObj: any): number;
/**
 * Benchmarking "consumer" that calculates two averages of two values, it takes a callback which enables this benchmark
 * to be used with any shape of tree since the callback defines the tree navigation.
 * @param cursor - a Shared Tree cursor
 * @param dataConsumer - Function that should use the given cursor to retrieve data and call calculate().
 * @returns a set of two average values.
 */
export declare function averageTwoValues(cursor: ITreeCursor, dataConsumer: (cursor: ITreeCursor, calculate: (x: number, y: number) => void) => number): [number, number];
//# sourceMappingURL=benchmarks.d.ts.map