/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { FieldKey } from "../../../core/index.js";
export interface Canada {
    type: "FeatureCollection";
    features: [
        {
            type: "Feature";
            properties: {
                name: "Canada";
            };
            geometry: {
                type: "Polygon";
                coordinates: [number, number][][];
            };
        }
    ];
}
export declare const Canada: {
    SharedTreeFieldKey: {
        features: FieldKey;
        geometry: FieldKey;
        coordinates: FieldKey;
    };
};
/**
 * Generates a Jsonable tree with statistical similarities to 'canada.json':
 * https://raw.githubusercontent.com/serde-rs/json-benchmark/master/data/canada.json
 */
export declare function generateCanada(segmentLengths?: number[], seed?: number): Canada;
//# sourceMappingURL=canada.d.ts.map