/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { SchemaBuilder } from "../../../domains/index.js";
import { typeNameSymbol } from "../../../feature-libraries/index.js";
const builder = new SchemaBuilder({ scope: "Simple Schema" });
// Schema
export const pointSchema = builder.object("point", {
    x: builder.number,
    y: builder.number,
});
export const appSchemaData = builder.intoSchema(builder.sequence(pointSchema));
// Schema aware types
// Example Use
// More Schema aware APIs
{
    const point = {
        x: 1,
        y: 2,
    };
    const point2 = {
        [typeNameSymbol]: pointSchema.name,
        x: 1,
        y: 1,
    };
}
//# sourceMappingURL=schemaSimple.js.map