/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { IIdCompressor } from "@fluidframework/id-compressor";
import { Populated } from "../../../util/index.js";
import { TestChange } from "../../testChange.js";
import { CellMark } from "../../../feature-libraries/sequence-field/index.js";
import { MarkEffect } from "../../../feature-libraries/sequence-field/types.js";
export type PopulatedMark<TNodeChange = TestChange> = Populated<CellMark<Populated<MarkEffect>, TNodeChange>>;
/**
 * Generates a list of marks with all fields populated.
 *
 * @remarks - New objects are generated every time this function is called. This is to ensure that stable IDs are
 * generated when appropriate.
 */
export declare function generatePopulatedMarks(idCompressor: IIdCompressor): PopulatedMark[];
//# sourceMappingURL=populatedMarks.d.ts.map