/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
export declare class Merged {
}
export declare class Conflicted extends Merged {
    constructor(o: unknown);
}
export declare class ConflictedMap extends Map {
    constructor(map: Map<unknown, unknown>);
}
export declare class Conflict extends Merged {
    readonly lhs: unknown;
    readonly rhs: unknown;
    constructor(lhs: unknown, rhs: unknown);
}
/**
 * Utility function for comparing two objects.
 * Supports data that could be roundtrip through `JSON.stringify`/`JSON.parse`.
 * @returns An object that represents a merged view of the given objects.
 */
export declare function merge<T>(lhs: T, rhs: T): Conflicted | Conflict | ConflictedMap | T;
//# sourceMappingURL=objMerge.d.ts.map