/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { IFluidDataStoreRuntime } from "@fluidframework/datastore-definitions";
import { SharedTreeBranch, SharedTreeCore, Summarizable } from "../../shared-tree-core/index.js";
import { DefaultChangeset, DefaultEditBuilder, TreeCompressionStrategy } from "../../feature-libraries/index.js";
import { TreeStoredSchemaSubscription } from "../../core/index.js";
/**
 * A `SharedTreeCore` with
 * - some protected methods exposed
 * - encoded data schema validation enabled
 */
export declare class TestSharedTreeCore extends SharedTreeCore<DefaultEditBuilder, DefaultChangeset> {
    private static readonly attributes;
    constructor(runtime?: IFluidDataStoreRuntime, id?: string, summarizables?: readonly Summarizable[], schema?: TreeStoredSchemaSubscription, chunkCompressionStrategy?: TreeCompressionStrategy);
    getLocalBranch(): SharedTreeBranch<DefaultEditBuilder, DefaultChangeset>;
}
//# sourceMappingURL=utils.d.ts.map