/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { ImplicitFieldSchema, TreeFieldFromImplicitField, InsertableTreeFieldFromImplicitField } from "../../simple-tree/index.js";
/**
 * Given the schema and initial tree data, returns a hydrated tree node.
 *
 * For minimal/concise targeted unit testing of specific simple-tree content.
 */
export declare function hydrate<TSchema extends ImplicitFieldSchema>(schema: TSchema, initialTree: InsertableTreeFieldFromImplicitField<TSchema>): TreeFieldFromImplicitField<TSchema>;
/**
 * Similar to JSON stringify, but allows `undefined` at the root and returns numbers as-is at the root.
 */
export declare function pretty(arg: unknown): number | string;
//# sourceMappingURL=utils.d.ts.map