/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { ChangeRebaser } from "../../core/index.js";
/**
 *
 * @param rebaser - `ChangeRebaser` instance used to combine generated changes
 * @param changeGenerator - Random change generator function
 * @param seed - Seed used to randomly generate and combine the changes
 * @param maxCombinations - Maximum number of changes to combine in order
 * to produce the final change. Must be greater or equal to 0.
 * @returns A random change resulting from the combination of several random changes.
 */
export declare function generateFuzzyCombinedChange<TChange>(rebaser: ChangeRebaser<TChange>, changeGenerator: (seed: number) => TChange, seed: number, maxCombinations: number): TChange;
//# sourceMappingURL=fuzz.d.ts.map